/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package des;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;


public class DoubleDes {
  private DesEncrypter encrypter1;
  private DesEncrypter encrypter2;

  
  public DoubleDes(byte[] bytekey1, byte[] bytekey2){
    try {  
      SecretKeyFactory skf = SecretKeyFactory.getInstance("DES");
      SecretKey key1 = skf.generateSecret(new DESKeySpec(bytekey1));
      SecretKey key2 = skf.generateSecret(new DESKeySpec(bytekey2));
      encrypter1 = new DesEncrypter(key1);
      encrypter2 = new DesEncrypter(key2);

    }
    catch(Exception e){
      
    }
  }
  
  
  public void encrypt(String plainText, String cypherText) throws FileNotFoundException{
      File plainTextFile=new File(plainText);
      File cypherTextFile=new File(cypherText);
      File helperFile=new File("ddesHelp");
      encrypter1.encrypt(new FileInputStream(plainTextFile),new FileOutputStream(helperFile));
      encrypter2.encrypt(new FileInputStream(helperFile),new FileOutputStream(cypherTextFile));
      
    
    
  }
  
  public void decrypt(String cypherText, String plainText) throws FileNotFoundException{
    File plainTextFile=new File(plainText);
    File cypherTextFile=new File(cypherText);
    File helperFile=new File("ddesHelp");
    
    encrypter2.decrypt(new FileInputStream(cypherTextFile),new FileOutputStream(helperFile));    
    encrypter1.decrypt(new FileInputStream(helperFile),new FileOutputStream(plainTextFile));
      
        
  }
  public static String removeParity(String pwd){
    byte[] source=pwd.getBytes();
    int[] help=new int[8];
    int[] dest=new int[7];
    
    
    for (int i=0;i<8;i++)
        help[i]=source[i] & 0xFF; //conversione da unsigned byte a int

    dest[6]=(help[7]>>1)+((help[6]>>1)<<7)& 0x000000FF;
	dest[5]=(help[6]>>2)+((help[5]>>1)<<6)& 0x000000FF;
	dest[4]=(help[5]>>3)+((help[4]>>1)<<5)& 0x000000FF;
	dest[3]=(help[4]>>4)+((help[3]>>1)<<4)& 0x000000FF;
	dest[2]=(help[3]>>5)+((help[2]>>1)<<3)& 0x000000FF;
	dest[1]=(help[2]>>6)+((help[1]>>1)<<2)& 0x000000FF;
	dest[0]=(help[1]>>7)+((help[0]>>1)<<1)& 0x000000FF;




    String pt1="";
    for (int i=0;i<7;i++){
      if (dest[i]<16)
        pt1+='0';
      pt1+=Integer.toHexString(dest[i]);
    }
    return pt1;
}
  
  
}
